Debian Bug report logs - #698133
kgb-client: Should not resend the whole history when pushing branches with content merged from other branches

version graph

Package: kgb-client; Maintainer for kgb-client is Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>; Source for kgb-client is src:kgb-bot.

Reported by: Raphaël Hertzog <hertzog@debian.org>

Date: Mon, 14 Jan 2013 10:06:02 UTC

Severity: normal

Found in version kgb-bot/1.05-1+squeeze1

Fixed in version kgb-bot/1.26-1

Done: Damyan Ivanov <dmn@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>:
Bug#698133; Package kgb-client. (Mon, 14 Jan 2013 10:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphaël Hertzog <hertzog@debian.org>:
New Bug report received and forwarded. Copy sent to Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>. (Mon, 14 Jan 2013 10:06:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Raphaël Hertzog <hertzog@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: kgb-client: Should not resend the whole history when pushing branches with content merged from other branches
Date: Mon, 14 Jan 2013 11:04:39 +0100
Package: kgb-client
Version: 1.05-1+squeeze1
Severity: normal

In the dpkg repository, we have multiple branches. I maintain the
squeeze-backports branch... most of the commits in that branch are
just commits merged from master. Those commits should not be reported...
we already saw them. Instead it should just report the merge commit
and commits specific to that branch.

The basic rule is "any commit that is already present in another branch
should not be reported".

It's not to difficult to implement. git-commit-notice on alioth already
has some logic to prevent this in the "report by mail" case. You can check
it out if you want.

Cheers,

-- System Information:
Debian Release: 7.0
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (1, 'experimental')
Architecture: amd64 (x86_64)
Foreign Architectures: i386

Kernel: Linux 3.6-trunk-amd64 (SMP w/4 CPU cores)
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash



Information forwarded to debian-bugs-dist@lists.debian.org, Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>:
Bug#698133; Package kgb-client. (Mon, 14 Jan 2013 15:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>. (Mon, 14 Jan 2013 15:57:03 GMT) Full text and rfc822 format available.

Message #10 received at 698133@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Raphaël Hertzog <hertzog@debian.org>, 698133@bugs.debian.org
Subject: Re: [kgb-maintainers] Bug#698133: kgb-client: Should not resend the whole history when pushing branches with content merged from other branches
Date: Mon, 14 Jan 2013 16:54:23 +0100
[Message part 1 (text/plain, inline)]
On Mon, 14 Jan 2013 11:04:39 +0100, Raphaël Hertzog wrote:

> In the dpkg repository, we have multiple branches. I maintain the
> squeeze-backports branch... most of the commits in that branch are
> just commits merged from master. Those commits should not be reported...
> we already saw them. Instead it should just report the merge commit
> and commits specific to that branch.
> 
> The basic rule is "any commit that is already present in another branch
> should not be reported".

Right, this feature has been requested before, and dam has already
started to work on it.
 
> It's not to difficult to implement. git-commit-notice on alioth already
> has some logic to prevent this in the "report by mail" case. You can check
> it out if you want.

Thanks for the hint!
 

Cheers,
gregor

-- 
 .''`.  Homepage: http://info.comodo.priv.at/ - OpenPGP key 0xBB3A68018649AA06
 : :' : Debian GNU/Linux user, admin, and developer  -  http://www.debian.org/
 `. `'  Member of VIBE!AT & SPI, fellow of the Free Software Foundation Europe
   `-   NP: Leonard Cohen: The Partisan
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>:
Bug#698133; Package kgb-client. (Mon, 14 Jan 2013 17:21:03 GMT) Full text and rfc822 format available.

Message #13 received at 698133@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: Raphaël Hertzog <hertzog@debian.org>, 698133@bugs.debian.org
Subject: Re: [kgb-maintainers] Bug#698133: kgb-client: Should not resend the whole history when pushing branches with content merged from other branches
Date: Mon, 14 Jan 2013 19:12:43 +0200
[Message part 1 (text/plain, inline)]
Control: -1 tags confirmed help

-=| Raphaël Hertzog, 14.01.2013 11:04:39 +0100 |=-
> Package: kgb-client
> Version: 1.05-1+squeeze1
> Severity: normal
> 
> In the dpkg repository, we have multiple branches. I maintain the
> squeeze-backports branch... most of the commits in that branch are
> just commits merged from master. Those commits should not be reported...
> we already saw them. Instead it should just report the merge commit
> and commits specific to that branch.
> 
> The basic rule is "any commit that is already present in another branch
> should not be reported".

Unless both branches are being pushed in which case we lose the commit 
as it is always present in another branch at the time the hook is 
invoked.

> It's not to difficult to implement. git-commit-notice on alioth 
> already has some logic to prevent this in the "report by mail" case. 
> You can check it out if you want.

My attempts are towards reworking the current logic by using 
git-rev-list, which avoids reporting commits twice nicely. The hard 
thing seems to be tracking which branch each commit was made to.

Even if I haven't lost all hope to fix this myself, this hasn't 
happened during months already, so help is very welcome.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>:
Bug#698133; Package kgb-client. (Wed, 16 Jan 2013 07:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>. (Wed, 16 Jan 2013 07:36:03 GMT) Full text and rfc822 format available.

Message #18 received at 698133@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Damyan Ivanov <dmn@debian.org>
Cc: 698133@bugs.debian.org
Subject: Re: [kgb-maintainers] Bug#698133: kgb-client: Should not resend the whole history when pushing branches with content merged from other branches
Date: Wed, 16 Jan 2013 08:32:16 +0100
Hi,

On Mon, 14 Jan 2013, Damyan Ivanov wrote:
> Unless both branches are being pushed in which case we lose the commit 
> as it is always present in another branch at the time the hook is 
> invoked.

Right, you still have the possibility to read the whole input and use that
information to update your knowledge of where things used to point before
the push.

> > It's not to difficult to implement. git-commit-notice on alioth 
> > already has some logic to prevent this in the "report by mail" case. 
> > You can check it out if you want.
> 
> My attempts are towards reworking the current logic by using 
> git-rev-list, which avoids reporting commits twice nicely. The hard 
> thing seems to be tracking which branch each commit was made to.

Why does it matter which branch a commit was made to? What matters is
where it appears first when it's pushed.

The code used to find out which commits can be reported is (to be run for
each updated branch).

git rev-parse --not --branches | grep -v $(git rev-parse $refname) | \
    git rev-list --stdin $oldrev..$newrev

Now if you really care about the case where a new commit is pushed to
two refs at the same time, then you can replace the initial "git rev-parse
--not --branches" by something of your own where you put those values
except that you substitute any updated commit by its former value.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Get the Debian Administrator's Handbook:
→ http://debian-handbook.info/get/



Added tag(s) pending. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Mon, 04 Feb 2013 21:21:04 GMT) Full text and rfc822 format available.

Reply sent to Damyan Ivanov <dmn@debian.org>:
You have taken responsibility. (Thu, 28 Mar 2013 07:06:17 GMT) Full text and rfc822 format available.

Notification sent to Raphaël Hertzog <hertzog@debian.org>:
Bug acknowledged by developer. (Thu, 28 Mar 2013 07:06:17 GMT) Full text and rfc822 format available.

Message #25 received at 698133-close@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: 698133-close@bugs.debian.org
Subject: Bug#698133: fixed in kgb-bot 1.26-1
Date: Thu, 28 Mar 2013 07:02:31 +0000
Source: kgb-bot
Source-Version: 1.26-1

We believe that the bug you reported is fixed in the latest version of
kgb-bot, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 698133@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Damyan Ivanov <dmn@debian.org> (supplier of updated kgb-bot package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 28 Mar 2013 08:41:36 +0200
Source: kgb-bot
Binary: kgb-bot kgb-client kgb-client-git
Architecture: source all
Version: 1.26-1
Distribution: unstable
Urgency: low
Maintainer: Debian KGB Maintainers <kgb-maintainers@lists.alioth.debian.org>
Changed-By: Damyan Ivanov <dmn@debian.org>
Description: 
 kgb-bot    - IRC collaboration bot
 kgb-client - client for KGB (IRC collaboration bot)
 kgb-client-git - client for KGB (IRC collaboration bot) - Git support
Closes: 691183 698133 699027
Changes: 
 kgb-bot (1.26-1) unstable; urgency=low
 .
   * update kgb-client.conf manual with the new options
   * rework Git branch walking
     avoids multiple notification about merged commits (Closes: #698133)
   * init: Use user configured in $RUN_AS as owner of logfiles.
     Otherwise log files created as 'Debian-kgb' can't be written to if the
     RUN_AS variable is modified
     Thanks to Alexander Barton for the patch.
     (Closes: #699027)
   * notify even if log message is invalid UTF-8
     notification with log of "(log is invalid UTF-8)" is better than
     no notification at all
     (Closes: #691183)
Checksums-Sha1: 
 db1e096a352554e119101fe870abf9ae9abad0fb 2524 kgb-bot_1.26-1.dsc
 b923082da2b6e86e77425e31bd4bdd12fc6468dc 73758 kgb-bot_1.26.orig.tar.gz
 88a38ca65161aa65e4f3c4c0c0f0d39c3f1c94d1 11103 kgb-bot_1.26-1.debian.tar.gz
 285e8c01741ac0a261f8b92bcf315c8e09f6732c 45230 kgb-bot_1.26-1_all.deb
 4f0138e5e81d0101886cd45c593ef56946a56993 69284 kgb-client_1.26-1_all.deb
 91afe4404325a4058bc23c30f3749d4e3e364146 24082 kgb-client-git_1.26-1_all.deb
Checksums-Sha256: 
 f002193b87ea31153b6c6063edc91dffc89b864cb659df9faa67619b6a959b4e 2524 kgb-bot_1.26-1.dsc
 41af7345e5a6405ddac88099a7c1adf8071c529927d2bc89b72d549d6c195c05 73758 kgb-bot_1.26.orig.tar.gz
 ebc54ff5f5728fcf7f748fe20f1d04f2a2854b7205d9f2cbf545f1422e4ed1f7 11103 kgb-bot_1.26-1.debian.tar.gz
 5c3b3b5a044337915fd3c508be3a37dae1acf1defbdce88d8df1ac6fad894541 45230 kgb-bot_1.26-1_all.deb
 ab7832d415b66cbee1604842cb351e9a4d267f51d7fc684e2fce1e5160b71c84 69284 kgb-client_1.26-1_all.deb
 4f56cf45cc83bc7186cdb3e7791636a852ab54d46e0da14af12bdeb66412e4d3 24082 kgb-client-git_1.26-1_all.deb
Files: 
 ce54595216b782de219af67f83256535 2524 devel optional kgb-bot_1.26-1.dsc
 d3532ab7336d9e1d732bc5769f9de897 73758 devel optional kgb-bot_1.26.orig.tar.gz
 75100e28b5b1dc8e3b2e799a30cbfc70 11103 devel optional kgb-bot_1.26-1.debian.tar.gz
 4170b08cf6123fb2471ad9997c0ca8fb 45230 devel optional kgb-bot_1.26-1_all.deb
 2b206c474328523780babde0dbb70cfc 69284 devel optional kgb-client_1.26-1_all.deb
 783c1ea3c39a9b984786d15a7598d639 24082 devel optional kgb-client-git_1.26-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJRU+n+AAoJENu+nU2Z0qAEQPYQAJSs5E0ZmSK4MS1JTvOOPB1G
ADjmTjzPY2Om9rDHjngq5HxORXQPRltkyTzLyet05rkEm5RVaZiLLgb+WV8W7MWl
vzktwnkOXLJvAwXgc4NHLhpKFcfzjhsS2VHKgoafvQest4hXdADeV4IZ35qaTgjX
t2ZDUhcP6wi49CO661SDI03ZwpCUoVIGiXaJTym3wBSv4J0NC9rK2CdNcflqnW6/
U4P+FVoy6Kp4A96UiDkTAL6FbeirZvsCpBD8AEfaTk94bg+PtuLHAnvBBhyRW/7U
buE24/R7ky0imIOYccn3PnqQ4Xlln8v9FE8P+xS5F/rsU9uJBECgyoybNclJ4ink
YgLX94f47/9y3eJqWzdAUJZgJcwlIk9BthrrIrpCef720nqMx9+h/m7A4hQAiS3M
ruVTHVWjxjN0fSvL84xGsgaR8TtqGFivarvgPNMSW65zOeXjqEs3CMtgZuc+fHWh
YOHY+W0sXchczrKFGXeuMgYTjK2gunJPQI3b4uOOL0xbcX56ReAq4twugTd+Py+f
Z5mehHkp+ARRh9Hz2y4Yg8RjHNGy8JZaS81dRuzp1dlJSrujFlYdUox9RxWt0oCB
KVY8lBv4Ed8vqypCgEV+J2S1VM4JzmwyPSyOo6obagtNJxc9TJTCxsPOLbS24RQq
gDczpS8Pxy0IqptCf7//
=WAQ6
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 25 Apr 2013 07:27:14 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 06:41:01 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.